var fs = require('fs');
var path = require('path');

var walk = function (dir, done) {
	var results = [];
	fs.readdir(dir, function (err, list) {
		if (err)
			return done(err);
		var pending = list.length;
		if (!pending)
			return done(null, results);
		list.forEach(function (file) {
			if(dir[dir.length-1] == '/'){
				file = dir + file
			}else{
				file = dir + '/' + file;
			}
		
			fs.stat(file, function (err, stat) {
				if (stat && stat.isDirectory()) {
					walk(file, function (err, res) {
						results = results.concat(res);
						if (!--pending)
							done(null, results);
					});
				} else {
					results.push(file);
					if (!--pending)
						done(null, results);
				}
			});
		});
	});
};

var expand = function (name) {
	var root = '/';
	var results = [],
	parts,
	part;			
	if (/^\.\.?(\/|$)/.test(name)) {
			parts = [root, name].join('/').split('/');
	}else {
		parts = name.split('/');
	}
	for (var i = 0, length = parts.length; i < length; i++) {
		part = parts[i];
		if (part == '..') {
			results.pop();
		} else if (part != '.' && part != '') {
			results.push(part);
		}
	}
	return results.join('/');
};

var fileFiter = function (files){
	var result = [];
	for(var i=0,l=files.length;i<l;i++){
		if(files[i].indexOf('.DS_Store') == -1){
			result.push(files[i]);
			
		}
	}
	return result;
};

var mkdirs = function(dirpath, mode, callback) {
    path.exists(dirpath, function(exists) {
        if(exists) {
			callback(dirpath);
        } else {
			//尝试创建父目录，然后再创建当前目录
			mkdirs(path.dirname(dirpath), mode, function(){
				fs.mkdir(dirpath, mode, callback);
			});
        }
    });
};

exports.mkdirs = mkdirs;
exports.walk = walk;
exports.fileFiter = fileFiter;
exports.expand = expand;